;pro lonmerge,inpnt,astfile,outpnt
inpnt = 'lon971015.pnt'
astfile = '971016.spot'
ppmfile = 'lon971015.ppm'
outpnt = 'new.pnt'

readcol,inpnt,haobs,decobs,hatrue0,dectrue0,ppmnum,flag,format='d,d,d,d,l,a',/silent
readcol,astfile,fn,day,time,xc,yc,ras,decs,format='a,a,a,f,f,a,a',/silent
readcol,ppmfile,ppm0,ppmras,ppmdecs,ppmdra,ppmddec,format='a,a,a,f,f',/silent
hatrue0=hatrue0*15.0d0/180.0d0*!dpi
ra=raparse(ras)
dec=decparse(decs)
pra0=raparse(ppmras)
pdec0=decparse(ppmdecs)

; Select the pixel spot
z = where(xc eq 2048.0 and yc eq 2048.0)
fn=fn[z]
day=day[z]
time=time[z]
xc=xc[z]
yc=yc[z]
ra=ra[z]
dec=dec[z]

lat =  35.09683102d0  ; Larry's values
lon = 111.5359167d0

; Match up the PPM coordinates with the input list
npnt = n_elements(haobs)
nspt = n_elements(fn)
nppm = n_elements(ppm0)

; link up catalog coordinates with the input pointing data list.
pidx=intarr(npnt)
FOR i=0,npnt-1 DO BEGIN
   z=where(ppmnum[i] eq ppm0)
   pidx[i] = z[0]
   IF pidx[i] eq -1 THEN pidx[i]=0
ENDFOR

; Copy out data, correct for proper motion and precess to ofdate.
pra=pra0[pidx]+(1997.79-2000.0)*ppmdra[pidx]/3600.0d0*15.0d0/180.0d0*!dpi
pdec=pdec0[pidx]+(1997.79-2000.0)*ppmddec[pidx]/3600.0d0/180.0d0*!dpi
precess,pra,pdec,2000.0,1997.79,/radian

lst=hatrue0-pra

sidx=intarr(npnt)
minsep=fltarr(npnt)
FOR i=0,npnt-1 DO BEGIN
   angsep = acos(sin(pdec[i])*sin(dec)+ $
                 cos(pdec[i])*cos(dec)*cos(pra[i]-ra))
   z=where(angsep eq min(angsep))
   z=z[0]
   sidx[i] = z
   minsep[i] = min(angsep)*!radeg*3600.0
   IF sidx[i] eq -1 THEN sidx[i]=0
ENDFOR

hatrue=lst+ra[sidx]
hatrue=hatrue/15.0d0*180.0d0/!dpi
hatrue0=hatrue0/15.0d0*180.0d0/!dpi
z=where(hatrue ge 12.0,count)
IF count ne 0 THEN hatrue[z] = hatrue[z] - 24.0d0
dectrue = dec[sidx] * 180.0d0 / !dpi


FOR i=0,npnt-1 DO BEGIN
   rastr,ra[sidx[i]],1,ras
   decstr,dec[sidx[i]],0,decs
   rastr,pra[i],1,ras1
   decstr,pdec[i],0,decs1
   IF minsep[i] lt 10000.0 THEN BEGIN
      print,haobs[i],decobs[i],hatrue[i],dectrue[i],ppmnum[i],' ',flag[i]
   ENDIF
ENDFOR

end
