;file = 'lon971015.pnt'
rdpoint,file,raobs,decobs,ratrue,dectrue,sidtime

i=indgen(n_elements(raobs))
idx=where(i ne 0 and i ne 1)
i=i[idx]
raobs   = raobs[i]
ratrue  = ratrue[i]
decobs  = decobs[i]
dectrue = dectrue[i]

haobs   = sidtime-raobs
hatrue  = sidtime-ratrue

raobs_r  = raobs   / 180.0d0 * !dpi
haobs_r  = haobs   / 180.0d0 * !dpi
decobs_r = decobs  / 180.0d0 * !dpi
ratrue_r = ratrue  / 180.0d0 * !dpi
dectrue_r= dectrue / 180.0d0 * !dpi
hatrue_r = hatrue  / 180.0d0 * !dpi

pntfit,raobs,decobs,ratrue,dectrue,sidtime,coefs,rafix,decfix,dha,ddec,title=file
hafix   = sidtime-rafix
coeff_lar=[12.9258d0,46.8886d0,14.2884d0,283.0332d0,26.9627d0,-36.1962d0,15.7605d0,-39.8243d0,0.740887d0]
old_coef=[-0.6,-56.7,28.5,78.5,-16.1,68.5,6.3,-47.2,0.]
old_coef=[-0.6+18.9,-56.7-89.31,28.5,78.5,-16.1,68.5,6.3,-47.2,0.]
;coefs=old_coef
pntfix,coefs,haobs,decobs,hafix,decfix,dha,ddec
rafix  = sidtime - hafix

pntfix,coefs,haobs,decobs,hafix1,decfix1,dha1,ddec1
rafix1  = sidtime - hafix1

radif = (ratrue - raobs) * 3600.0d0 * cos(dectrue_r)
decdif = (dectrue - decobs) * 3600.0d0

raresid = (ratrue - rafix) * 3600.0d0 * cos(dectrue_r)
decresid = (dectrue - decfix) * 3600.0d0

raresid1 = (ratrue - rafix1) * 3600.0d0 * cos(dectrue_r)
decresid1 = (dectrue - decfix1) * 3600.0d0

hafix_r   = hafix   / 180.0d0 * !dpi
decfix_r  = decfix  / 180.0d0 * !dpi
hafix1_r  = hafix1  / 180.0d0 * !dpi
decfix1_r = decfix1 / 180.0d0 * !dpi

lat =  35.0966833d0  ; Larry's values
lon = 111.5359167d0

;lat=35.0967189d0    ; GPS value for 42"
;lon=111.5365053d0

lat_r=lat/180.0d0*!dpi
lon_r=lon/180.0d0*!dpi

alttrue_r=asin(sin(lat_r)*sin(dectrue_r)+cos(lat_r)*cos(dectrue_r)*cos(hatrue_r))
altobs_r=asin(sin(lat_r)*sin(decobs_r)+cos(lat_r)*cos(decobs_r)*cos(haobs_r))
altfix_r=asin(sin(lat_r)*sin(decfix_r)+cos(lat_r)*cos(decfix_r)*cos(hafix_r))

aztrue_r=atan(sin(hatrue_r),cos(hatrue_r)*sin(lat_r)-tan(dectrue_r)*cos(lat_r))
azobs_r=atan(sin(haobs_r),cos(haobs_r)*sin(lat_r)-tan(decobs_r)*cos(lat_r))
azfix_r=atan(sin(hafix_r),cos(hafix_r)*sin(lat_r)-tan(decfix_r)*cos(lat_r))

alttrue  = alttrue_r * 180.0d0 / !dpi
altobs   = altobs_r  * 180.0d0 / !dpi
altfix   = altfix_r  * 180.0d0 / !dpi

aztrue   = aztrue_r  * 180.0d0 / !dpi
azobs    = azobs_r   * 180.0d0 / !dpi
azfix    = azfix_r   * 180.0d0 / !dpi

zentrue  = 90.0d0 - alttrue
zenobs   = 90.0d0 - altobs
zenfix   = 90.0d0 - altfix

obssep_r=acos(sin(dectrue_r)*sin(decobs_r) + $
              cos(dectrue_r)*cos(decobs_r)*cos(hatrue_r-haobs_r))
obssep=obssep_r*!radeg*3600.0

resid_r =acos(sin(dectrue_r)*sin(decfix_r) + $
              cos(dectrue_r)*cos(decfix_r)*cos(hatrue_r-hafix_r))
resid=resid_r*!radeg*3600.0

fixsep_r=acos(sin(decobs_r)*sin(decfix_r) + $
              cos(decobs_r)*cos(decfix_r)*cos(hafix_r-haobs_r))
fixsep=fixsep_r*!radeg*3600.0

!p.multi=[0,1,3]
xt='Observation #'
plot,radif,psym=5,xtit=xt,ytit='RA err (")'
oplot,raresid,psym=4
oplot,raresid1,psym=3
plot,decdif,psym=5,xtit=xt,ytit='Dec err (")'
oplot,decresid,psym=4
oplot,decresid1,psym=3

plot,obssep,psym=4,yr=[0,max([obssep,fixsep,resid])],xtit=xt,ytit='Separation (")'
oplot,fixsep,psym=5
oplot,resid,psym=2
xyouts,0.5,0.98,'Pointing data from '+file,align=0.5,/normal

!p.multi=0

if !d.name eq 'PS' then device,xsize=15,ysize=15

x=zentrue*cos(aztrue_r)
y=zentrue*sin(aztrue_r)
nobs=n_elements(x)

if !d.name eq 'SUN' or !d.name eq 'X' then begin
   device,window_state=win_state
   if win_state[3] eq 1 then wset,3 else window,3,xsize=400,ysize=400
endif

fac=300
dx=(zentrue*cos(aztrue_r)-zenobs*cos(azobs_r))*fac
dy=(zentrue*sin(aztrue_r)-zenobs*sin(azobs_r))*fac

setusym,-1
xr=[-60.,60]
yr=[-60.,60]
plot,x,y,psym=8,symsize=0.5,xr=xr,yr=yr
for i=0,nobs-1 do plots,[x[i],x[i]+dx[i]],[y[i],y[i]+dy[i]]
setusym,1
xyouts,0.,-77.0,'East',align=0.5
xyouts,0.,68.0,'West',align=0.5
xyouts,-72.0,0.,'North',align=0.5,orient=90
xyouts,67.0,0.,'South',align=0.5,orient=270

xyouts,-70,68,string(fac)+'X',align=0.0
azstrip=findgen(101)/100.*360./!radeg
for zenan=15,60,15 do begin
   xaz=zenan*cos(azstrip)
   yaz=zenan*sin(azstrip)
   oplot,xaz,yaz,linestyle=1
endfor

zenan=[0.0,60.0]
for azstrip=0,360,30 do begin
   xaz=zenan*cos(azstrip/!radeg)
   yaz=zenan*sin(azstrip/!radeg)
   oplot,xaz,yaz,linestyle=1
endfor

if !d.name eq 'PS' then begin
   xyouts,1.15,0.80,'Pointing file '+file,/normal
   xyouts,1.15,0.75,'Raw data',/normal
   xyouts,1.15,0.70,'o - catalog position',/normal
   xyouts,1.15,0.65,'arrows point to observed position.',/normal
   xyouts,1.15,0.60,'RA pointing',/normal
   xyouts,1.15,0.55,'   scatter'+string(mean(abs(radif)),form='(f7.2)')+' arcsec',/normal
   xyouts,1.15,0.50,'   worst  '+string(max(abs(radif)),form='(f7.2)')+' arcsec',/normal
   xyouts,1.15,0.45,'   best   '+string(min(abs(radif)),form='(f7.2)')+' arcsec',/normal
   xyouts,1.15,0.40,'   p-p    '+string(max(radif)-min(radif),form='(f7.2)')+' arcsec',/normal
   xyouts,1.15,0.35,'Dec pointing',/normal
   xyouts,1.15,0.30,'   scatter'+string(mean(abs(decdif)),form='(f7.2)')+' arcsec',/normal
   xyouts,1.15,0.25,'   worst  '+string(max(abs(decdif)),form='(f7.2)')+' arcsec',/normal
   xyouts,1.15,0.20,'   best   '+string(min(abs(decdif)),form='(f7.2)')+' arcsec',/normal
   xyouts,1.15,0.15,'   best   '+string(min(abs(decdif)),form='(f7.2)')+' arcsec',/normal
   xyouts,1.15,0.10,'   best   '+string(max(decdif)-min(decdif),form='(f7.2)')+' arcsec',/normal
endif

if !d.name eq 'SUN' or !d.name eq 'X' then begin
   device,window_state=win_state
   if win_state[2] eq 1 then wset,2 else window,2,xsize=400,ysize=400
endif

fac=1000
dx=(zentrue*cos(aztrue_r)-zenfix*cos(azfix_r))*fac
dy=(zentrue*sin(aztrue_r)-zenfix*sin(azfix_r))*fac

setusym,-1
xr=[-60.,60]
yr=[-60.,60]
plot,x,y,psym=8,symsize=0.5,xr=xr,yr=yr
for i=0,nobs-1 do plots,[x[i],x[i]+dx[i]],[y[i],y[i]+dy[i]]
setusym,1
xyouts,0.,-77.0,'East',align=0.5
xyouts,0.,68.0,'West',align=0.5
xyouts,-72.0,0.,'North',align=0.5,orient=90
xyouts,67.0,0.,'South',align=0.5,orient=270

xyouts,-70,68,string(fac)+'X',align=0.0
azstrip=findgen(101)/100.*360./!radeg
for zenan=15,60,15 do begin
   xaz=zenan*cos(azstrip)
   yaz=zenan*sin(azstrip)
   oplot,xaz,yaz,linestyle=1
endfor

zenan=[0.0,60.0]
for azstrip=0,360,30 do begin
   xaz=zenan*cos(azstrip/!radeg)
   yaz=zenan*sin(azstrip/!radeg)
   oplot,xaz,yaz,linestyle=1
endfor

if !d.name eq 'PS' then begin
   xyouts,1.10,0.80,'Pointing file '+file,/normal
   xyouts,1.10,0.76,'Corrected data',/normal
   xyouts,1.10,0.72,'o - catalog position',/normal
   xyouts,1.10,0.68,'arrows point to observed position.',/normal
   dl=-0.02
   pos=0.60
   cz=0.7
   fmt='(f11.6)'
   xyouts,1.10,pos+dl*0,string(coefs[0],form=fmt)+' Zero point in dec (")',/normal,charsize=cz
   xyouts,1.10,pos+dl*1,string(coefs[1],form=fmt)+' Zero point in ra (")',/normal,charsize=cz
   xyouts,1.10,pos+dl*2,string(coefs[2],form=fmt)+' Angle between true and instrumental poles (")',/normal,charsize=cz
   xyouts,1.10,pos+dl*3,string(coefs[3],form=fmt)+' Angle between line of pole and true meridian (deg)',/normal,charsize=cz
   xyouts,1.10,pos+dl*4,string(coefs[4],form=fmt)+' Telescope tube droop in HA and DEC (")',/normal,charsize=cz
   xyouts,1.10,pos+dl*5,string(coefs[5],form=fmt)+' Angle between optical and telescope tube axes (")',/normal,charsize=cz
   xyouts,1.10,pos+dl*6,string(coefs[6],form=fmt)+' Mechanical orthogonality of RA and DEC axes (")',/normal,charsize=cz
   xyouts,1.10,pos+dl*7,string(coefs[7],form=fmt)+' Dec axis flexure (")',/normal,charsize=cz
   xyouts,1.10,pos+dl*8,string(coefs[8],form=fmt)+' HA encoder scale error ("/degree)',/normal,charsize=cz
   xyouts,1.15,pos+dl*10,'RA pointing',/normal,charsize=cz
   xyouts,1.15,pos+dl*11,'   scatter'+string(mean(abs(raresid)),form='(f7.2)')+' arcsec',/normal,charsize=cz
   xyouts,1.15,pos+dl*12,'   worst  '+string(max(abs(raresid)),form='(f7.2)')+' arcsec',/normal,charsize=cz
   xyouts,1.15,pos+dl*13,'   best   '+string(min(abs(raresid)),form='(f7.2)')+' arcsec',/normal,charsize=cz
   xyouts,1.15,pos+dl*14,'   p-p    '+string(max(raresid)-min(raresid),form='(f7.2)')+' arcsec',/normal,charsize=cz
   xyouts,1.15,pos+dl*15,'Dec pointing',/normal,charsize=cz
   xyouts,1.15,pos+dl*16,'   scatter'+string(mean(abs(decresid)),form='(f7.2)')+' arcsec',/normal,charsize=cz
   xyouts,1.15,pos+dl*17,'   worst  '+string(max(abs(decresid)),form='(f7.2)')+' arcsec',/normal,charsize=cz
   xyouts,1.15,pos+dl*18,'   best   '+string(min(abs(decresid)),form='(f7.2)')+' arcsec',/normal,charsize=cz
   xyouts,1.15,pos+dl*19,'   p-p    '+string(max(decresid)-min(decresid),form='(f7.2)')+' arcsec',/normal,charsize=cz
endif

if !d.name eq 'SUN' or !d.name eq 'X' then wset,0

end
